/*!
 * @file synchronizeable_int.h
 * @brief Definition of SynchronizeableInt
*/

#include "synchronizeable_var/synchronizeable_var.h"

#ifndef _SYNCHRONIZEABLE_INT_H
#define _SYNCHRONIZEABLE_INT_H

class SynchronizeableInt : public SynchronizeableVar {

  public:
    SynchronizeableInt( int * ptrIn, int * ptrOut, std::string name, int permission = 0, int priority = 0 );
    virtual ~SynchronizeableInt();
    
    virtual int writeToBuf( byte * buf, int maxLength );
    virtual int readFromBuf( byte * buf, int maxLength );
    
  private:
    int * vPtrIn;       //!< pointer to data (read)
    int * vPtrOut;      //!< pointer to data (write)


};

#endif /* _PROTO_CLASS_H */
